--method by insanto
fn isPointInVol obj pos = --checks if supplied position is inside supplied mesh object
(
	if superclassOf obj == geometryClass do ;
	(
		local tMesh = obj.mesh
		local nVerts=tMesh.numverts
		local isInVol = true
		for v = 1 to nVerts while isInVol do if asin (dot (getNormal tMesh v) (normalize(((getVert tMesh v)*obj.transform) - pos))) <= 0.0 do isInVol = false
		tMesh = nVerts = vPos = undefined
		return isInVol
	)
)--END isPointInVol FN
		

--method by Klaas Nienhuis
function fn_isObjInsideVolume theObj theVolume=
(
	/*
	fn_isObjInsideVolume
	handles the calculation if an object is within a specified mesh-volume
	*/
	local inside = false
-- 	addModifier theVolume (normalModifier flip:true)
	theVolume.modifiers[1].flip = true
	local myHit = intersectRay theVolume (ray theObj.pos [0,0,1])
	if myHit == undefined then
	(
		inside = false
		)else 
		(
			theVolume.modifiers[1].flip = false
			local myHit2 = intersectRay theVolume (ray theObj.pos [0,0,1])
			if myHit2 == undefined OR (distance myHit.pos theObj.pos) < (distance myHit2.pos theObj.pos) then
		(
			inside = true
		)else
		(
			inside = false
		)
	)
-- 	deleteModifier theVolume 1
	inside
)


--testing method
function fn_test arrPoint &time1 &time2 =
(
	st = timestamp()
	for p in arrPoint do isPointInVol $vol p.pos
	time1 = (timestamp()-st)

	st = timestamp()
	addModifier $vol (normalModifier flip:true)
	for p in arrPoint do fn_isObjInsideVolume p $vol
	time2 = (timestamp()-st)
	deleteModifier $vol 1

	gc()
)

time_isPointInVol = 0
time_fn_isObjInsideVolume = 0
for i = 1 to 10 do 
(
	local time1 = 0
	local time2 = 0
	fn_test selection &time1 &time2
	time_isPointInVol += time1
	time_fn_isObjInsideVolume += time2
)
	
format "isPointInVol: %ms\nfn_isObjInsideVolume: %ms\n" (time_isPointInVol/10) (time_fn_isObjInsideVolume/10)